package tech.powerjob.work.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 当前各个区域的船只统计信息
 * @TableName SHIP_LOCK_AREA_STATISTIC
 */
@TableName(value ="\"GHJG_CHANNEL\".\"SHIP_LOCK_AREA_STATISTIC\"")
@Data
public class ShipLockAreaStatistic implements Serializable {
    /**
     * 待闸区数量
     */
    @TableField("INSIDE_COUNT")
    private Long insideCount;

    /**
     * 候泊区数量
     */
    @TableField("OUTSIDE_COUNT")
    private Long outsideCount;

    /**
     * 
     */
    @TableField("DT_CREATE")
    private Date dtCreate;

    /**
     * 
     */
    @TableId("DATE_TIME")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date dateTime;

    @TableField("TOTAL")
    private Long total;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}