package tech.powerjob.work.service.impl;

import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import tech.powerjob.work.entity.ShipLockAreaStatistic;
import tech.powerjob.work.mapper.ShipLockAreaStatisticMapper;
import tech.powerjob.work.service.ShipLockAreaStatisticService;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import tech.powerjob.work.util.DateUtils;
import tech.powerjob.work.util.ReturnMsg;
import tech.powerjob.worker.core.processor.ProcessResult;

import javax.annotation.Resource;
import java.text.ParseException;
import java.util.HashMap;

/**
 *
 */
@Service
@Slf4j
public class ShipLockAreaStatisticServiceImpl extends ServiceImpl<ShipLockAreaStatisticMapper, ShipLockAreaStatistic> implements ShipLockAreaStatisticService {
    @Value("${areaStatisticUrl}")
    private String areaStatisticUrl;
    @Value("${infoSecretId}")
    private String infoSecretId;
    @Value("${infoSecretKey}")
    private String infoSecretKey;

    @Resource
    private ShipLockAreaStatisticMapper statisticMapper;
    @Override
    public ProcessResult getAreaStatistic() {
        try {
            HttpResponse execute = HttpUtil.createGet(areaStatisticUrl).
                    header("secretId", infoSecretId).
                    header("secretKey", infoSecretKey).execute();
            HashMap hashMap = JSONObject.parseObject(execute.body(), HashMap.class);
            ShipLockAreaStatistic shipLockAreaStatistic = JSONObject.parseObject(hashMap.get("data").toString(), ShipLockAreaStatistic.class);
            shipLockAreaStatistic.setDateTime(DateUtils.stringToDate(DateUtils.dateToString(shipLockAreaStatistic.getDtCreate(), "yyyy-MM-dd"), "yyyy-MM-dd"));
            shipLockAreaStatistic.setTotal(shipLockAreaStatistic.getInsideCount() + shipLockAreaStatistic.getOutsideCount());
            //statisticMapper.getAll();
            this.saveOrUpdate(shipLockAreaStatistic);
        } catch (ParseException e) {
            log.error("访问接口{}出错{}",areaStatisticUrl,e.getMessage());
        }
        return ReturnMsg.returnMsg(true,"静态信息保存成功");
    }
}




