package tech.powerjob.work.service.impl;

import cn.hutool.http.HttpException;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import tech.powerjob.work.entity.ShipLockDoorStatusRealtime;
import tech.powerjob.work.mapper.ShipLockDoorStatusRealtimeMapper;
import tech.powerjob.work.service.ShipLockDoorStatusRealtimeService;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tech.powerjob.work.util.ReturnMsg;
import tech.powerjob.worker.core.processor.ProcessResult;

import java.util.HashMap;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 *
 */
@Service
@Transactional
@Slf4j
public class ShipLockDoorStatusRealtimeServiceImpl extends ServiceImpl<ShipLockDoorStatusRealtimeMapper, ShipLockDoorStatusRealtime> implements ShipLockDoorStatusRealtimeService {
    @Value("${shipLockDoorStatusUrl}")
    private String shipLockDoorStatusUrl;
    @Value("${shipLockSecretId}")
    private String shipLockSecretId;
    @Value("${shipLockSecretKey}")
    private String shipLockSecretKey;

    @Override
    public ProcessResult saveDoorStatus() {
        try {
            HttpResponse execute = HttpUtil.createGet(shipLockDoorStatusUrl).
                    header("secretId", shipLockSecretId).
                    header("secretKey", shipLockSecretKey).execute();
            execute.close();
            HashMap hashMap = JSONObject.parseObject(execute.body(), HashMap.class);
            if (new Integer(0).equals(hashMap.get("code"))) {
                List<ShipLockDoorStatusRealtime> data = JSONObject.parseArray(hashMap.get("data").toString(), ShipLockDoorStatusRealtime.class);
                data = data.stream().filter(Objects::nonNull).collect(Collectors.toList());
                data.forEach(i -> i.setDates(i.getDate()));
                for (ShipLockDoorStatusRealtime datum : data) {
                    System.out.println(datum);
                }
                boolean b = this.saveOrUpdateBatch(data);
                if (b) {
                    return new ProcessResult(true, "成功");
                } else {
                    return new ProcessResult(false, "失败");
                }
            }
            return ReturnMsg.returnMsg(true, "成功");
        } catch (HttpException e) {
            log.error("访问接口{}失败{}",shipLockDoorStatusUrl,e.getMessage());
            return ReturnMsg.returnMsg(false, "失败");
        }
    }
}
