package tech.powerjob.work.service.impl;

import cn.hutool.http.HttpException;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import tech.powerjob.work.entity.ShipLockShipStatus;
import tech.powerjob.work.mapper.ShipLockShipStatusMapper;
import tech.powerjob.work.service.ShipLockShipStatusService;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tech.powerjob.work.util.ReturnMsg;
import tech.powerjob.worker.core.processor.ProcessResult;

import java.util.HashMap;
import java.util.List;


/**
 *
 */

@Slf4j
@Service
@Transactional
public class ShipLockShipStatusServiceImpl extends ServiceImpl<ShipLockShipStatusMapper, ShipLockShipStatus> implements ShipLockShipStatusService {
    private static final String[] status = {"预申报", "候泊中", "待闸中", "过闸中", "已过闸"};
    @Value("${shipStatusUrl}")
    private String shipStatusUrl;
    @Value("${infoSecretId}")
    private String infoSecretId;
    @Value("${infoSecretKey}")
    private String infoSecretKey;

    @Override
    public ProcessResult saveShipStatus() {
        try {
            for (String s : status) {
                HttpResponse execute = HttpUtil.createGet(shipStatusUrl + "status=" + s + "&pageNum=1&pageSize=10000000").
                        header("secretId", infoSecretId).
                        header("secretKey", infoSecretKey).execute();
                execute.close();
                HashMap hashMap = JSONObject.parseObject(execute.body(), HashMap.class);
                if (new Integer(0).equals(hashMap.get("code"))) {
                    HashMap hashMap1 = JSONObject.parseObject(hashMap.get("data").toString(), HashMap.class);
                    List<ShipLockShipStatus> data = JSONObject.parseArray(hashMap1.get("records").toString(), ShipLockShipStatus.class);
                    this.saveOrUpdateBatch(data);
                }
            }
            return ReturnMsg.returnMsg(true);
        } catch (HttpException e) {
            log.error("访问接口{}出错{}",shipStatusUrl,e.getMessage());
            return ReturnMsg.returnMsg(false,"访问接口出现异常");
        }
    }
}

