package tech.powerjob.work.service.impl;

import cn.hutool.http.HttpException;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import tech.powerjob.work.entity.ShipLockStatistic;
import tech.powerjob.work.entity.ShipLockStatisticDetail;
import tech.powerjob.work.mapper.ShipLockStatisticMapper;
import tech.powerjob.work.service.ShipLockStatisticDetailService;
import tech.powerjob.work.service.ShipLockStatisticService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tech.powerjob.work.util.DateUtils;
import tech.powerjob.work.util.ReturnMsg;
import tech.powerjob.worker.core.processor.ProcessResult;

import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 *
 */
@Service
@Transactional
@Slf4j
public class ShipLockStatisticServiceImpl extends ServiceImpl<ShipLockStatisticMapper, ShipLockStatistic> implements ShipLockStatisticService {
    @Autowired
    private ShipLockStatisticDetailService shipLockStatisticDetailService;
    @Value("${lockStaticUrl}")
    private String lockStaticUrl;
    @Value("${infoSecretId}")
    private String infoSecretId;
    @Value("${infoSecretKey}")
    private String infoSecretKey;
    @Override
    public ProcessResult saveShipStatisticInfo() {
        try {
            String date = DateUtils.dateToString(new Date(), "yyyy-MM-dd");
            HttpResponse execute = HttpUtil.createGet(lockStaticUrl + "date=" + date).
                    header("secretId", infoSecretId).
                    header("secretKey", infoSecretKey).execute();
            execute.close();
            HashMap hashMap = JSONObject.parseObject(execute.body(), HashMap.class);
            if (new Integer(0).equals(hashMap.get("code"))){
                HashMap data = JSONObject.parseObject(hashMap.get("data").toString(), HashMap.class);
                ShipLockStatistic shipLockShipStatus = JSONObject.parseObject(hashMap.get("data").toString(), ShipLockStatistic.class);
                List<ShipLockStatisticDetail> details = JSONObject.parseArray(data.get("details").toString(), ShipLockStatisticDetail.class);
                this.saveOrUpdate(shipLockShipStatus);
                shipLockStatisticDetailService.saveOrUpdateBatch(details);
            }
            return ReturnMsg.returnMsg(true);
        } catch (HttpException e) {
            log.error("访问接口{}出现错误{}",lockStaticUrl,e.getMessage());
            return ReturnMsg.returnMsg(false,"出现异常");
        }
    }
}




