package tech.powerjob.work.service.impl;

import cn.hutool.http.HttpException;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import tech.powerjob.work.entity.ShipLockWaterLevel;
import tech.powerjob.work.entity.ShipRunInfo;
import tech.powerjob.work.mapper.ShipLockWaterLevelMapper;
import tech.powerjob.work.service.ShipLockWaterLevelService;
import tech.powerjob.work.service.ShipRunInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tech.powerjob.work.util.ReturnMsg;
import tech.powerjob.worker.core.processor.ProcessResult;

import java.util.HashMap;
import java.util.List;

/**
 *
 */
@Service
@Transactional
@Slf4j
public class ShipLockWaterLevelServiceImpl extends ServiceImpl<ShipLockWaterLevelMapper, ShipLockWaterLevel> implements ShipLockWaterLevelService{
    @Autowired
    private ShipRunInfoService shipRunInfoService;
    @Value("${shipLockWaterLevelUrl}")
    private String shipLockWaterLevelUrl;
    @Value("${shipLockSecretId}")
    private String shipLockSecretId;
    @Value("${shipLockSecretKey}")
    private String shipLockSecretKey;
    @Override
    public ProcessResult saveWaterLevel() {
        try {
            HttpResponse execute = HttpUtil.createGet(shipLockWaterLevelUrl).
                    header("secretId", shipLockSecretId).
                    header("secretKey", shipLockSecretKey).execute();
            execute.close();
            HashMap hashMap = JSONObject.parseObject(execute.body(), HashMap.class);
            if (new Integer(0).equals(hashMap.get("code"))){
                HashMap hashMap1 = JSONObject.parseObject(hashMap.get("data").toString(), HashMap.class);
                List<ShipRunInfo> shipRunInfos = JSONObject.parseArray(hashMap1.get("shipRunInfos").toString(), ShipRunInfo.class);
                shipRunInfos.forEach(i->i.setDateTime(i.getDate()));
                ShipLockWaterLevel data = JSONObject.parseObject(hashMap.get("data").toString(), ShipLockWaterLevel.class);
                data.setDateTime(data.getDate());
                this.saveOrUpdate(data);
                try {
                    shipRunInfoService.saveOrUpdateBatch(shipRunInfos);
                } catch (Exception e) {
                    log.error("保存失败");
                }
                return ReturnMsg.returnMsg(true);
            }
            return new ProcessResult(true);
        } catch (HttpException e) {
            log.error("访问接口{}出错{}",shipLockWaterLevelUrl,e.getMessage());
            return ReturnMsg.returnMsg(false,"出现异常");
        }
    }
}




